#include "stdlib.h"

main(int argc, char *argv[])
{
int ResetCount,PortStatus,MaxResets,Selection;
int Count,Countlowbyte,Counthighbyte;
	/* first check the number of parameters */
	if(argc<3) {
		printf("\n Invalid number of parameters for the Watchdog Timer");
		exit(0);
		}
	/* work out the Count for Counter0 */
	ResetCount=inportb(0x318); /* read the 8255 */
	PortStatus=ResetCount&0x80;
	if(PortStatus==0) {
		/* 8255 ports A,B,C are input,input,input respectively */
		outportb(0x31b,0x9b);
		}
	else {
		/* 8255 ports A,B,C are input,input,output respectively */
		outportb(0x31b,0x92);
		}
	ResetCount=ResetCount & 0x7f;
	printf("No of watchdog timer resets=%d\n",ResetCount);
	Count=atoi(argv[1]);
	MaxResets=atoi(argv[2]);
	if(MaxResets>0) {
		if(ResetCount>MaxResets) {
			printf("WARNING No of resets exceeds limit set of %d\n",MaxResets);
			printf("Press any Key to continue\n");
			/* something to catch your attention */
			while(!bioskey(1)) {
				sound(1000); delay(1000); sound(500); delay(1000);
				}
			bioskey(0);
			nosound();
		   printf("\nSelect Alternative 1 or 2\n");
		   printf("--------------------------------------------------\n");
		   printf("  1. Reset the Counter and activate the WDT\n");
		   printf("  2. Reset the Counter but do not activate the WDT\n");
		   printf("Selection - ");
		   scanf("%d",&Selection);
		   outportb(0x314,0x02); /* reset the counter, bring RCOUNT high and low */
		   outportb(0x314,0x00);
		   if(Selection==2) exit(0);
		   }
		}
	outportb(0x313,0x34);  /* set the mode of the Counter */
	Count=Count*200;  /* total number of pulses for the timeout period */
	Count=Count/10; 	/* divide it by 10 due to 4017 */
	Countlowbyte=Count%0x100;
	Counthighbyte=Count/0x100;
	outportb(0x310,Countlowbyte); /* write to the 8253 at address 0x310 */
	outportb(0x310,Counthighbyte);
	outportb(0x314,0x01);  /* bring the G0 line high to start the WDT */
}

